﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace GCodeGenerator
{
    public class CodeGeneration
    {
        StreamWriter writer;

        public CodeGeneration()
        {
            
        }

        public void MotorPlateHolesCG()
        {
            double x = 0.5;
            double y = 0.833;
            double xPattern = 0.75;
            int repeat = 20;

            using (writer = new StreamWriter("motorPlateHoles.txt"))
            {
                this.StartCode();
                for (int i = 0; i < repeat; i++)
                {
                    if (i == repeat - 1)
                    {
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                        writer.WriteLine("G1 Z-0.375");
                        writer.WriteLine("G1 Z0.125");
                        //writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 0.65).ToString());
                        //writer.WriteLine("G1 Z-0.375");
                        //writer.WriteLine("G1 Z0.125");
                        //writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 0.217).ToString());
                        //writer.WriteLine("G1 Z-0.375");
                        //writer.WriteLine("G1 Z0.125");
                        //writer.WriteLine("G1 X" + (x + 0.75).ToString() + "Y" + y.ToString());
                        //writer.WriteLine("G1 Z-0.375");
                        //writer.WriteLine("G1 Z0.125");
                    }
                    else
                    {
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                        writer.WriteLine("G1 Z-0.375");
                        writer.WriteLine("G1 Z0.125");
                        writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 0.65).ToString());
                        writer.WriteLine("G1 Z-0.375");
                        writer.WriteLine("G1 Z0.125");
                        //if (i < repeat - 1)
                        //{
                        //    writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 0.217).ToString());
                        //    writer.WriteLine("G1 Z-0.375");
                        //    writer.WriteLine("G1 Z0.125");
                        //    writer.WriteLine("G1 X" + (x + 0.75).ToString() + "Y" + (y + 0.433).ToString());
                        //    writer.WriteLine("G1 Z-0.375");
                        //    writer.WriteLine("G1 Z0.125");
                        //}
                    }
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void MotorPlateRotorHolesCG()
        {
            double x = 0.875;
            double y = 1.05;
            double xPattern = 0.75;
            int repeat = 20;

            using (writer = new StreamWriter("motorPlateRotorHoles.txt"))
            {
                this.StartCode();
                //this.FastenerHolesStart(2.5);
                for (int i = 0; i < repeat; i++)
                {
                    if (i == repeat - 1)
                    {
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                        writer.WriteLine("G1 Z-0.5");
                        writer.WriteLine("G1 Z0.125");
                    }
                    else
                    {
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                        writer.WriteLine("G1 Z-0.5");
                        writer.WriteLine("G1 Z0.125");
                        writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 0.22).ToString());
                        writer.WriteLine("G1 Z-0.5");
                        writer.WriteLine("G1 Z0.125");
                    }
                    x += xPattern;
                }
                //this.FastenerHolesEnd(2.5);
                this.EndCode();
            }
        }

        public void MotorPlatePocketsCG()
        {
            int repeat = 20;
            int steps = 3;
            double x = 0.875;
            double y = 1.05;
            double depth = -0.1;
            double depthStep = depth / steps;
            double r = 0.325;
            double millSize = 0.375;
            double xPattern = 0.75;
            using (writer = new StreamWriter("motorPlatePockets.txt"))
            {
                this.StartCode();
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + (x - r + millSize / 2).ToString() + "Y" + y.ToString());
                    for (int j = 0; j < steps; j++)
                    {
                        writer.WriteLine("G1 Z" + (depthStep + depthStep * j).ToString());
                        writer.WriteLine("G2 X" + (x + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                        writer.WriteLine("G2 X" + (x - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());
                    }
                    writer.WriteLine("G1 Z0.125");
                    if (i < repeat - 1)
                    {
                        writer.WriteLine("G1 X" + ((x + 0.375) - r + millSize / 2).ToString() + "Y" + (y + 0.217).ToString());
                        for (int j = 0; j < steps; j++)
                        {
                            writer.WriteLine("G1 Z" + (depthStep + depthStep * j).ToString());
                            writer.WriteLine("G2 X" + ((x + 0.375) + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                            writer.WriteLine("G2 X" + ((x + 0.375) - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());
                        }
                        writer.WriteLine("G1 Z0.125");
                    }
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void MotorPlatePocketsCGTest()
        {
            int repeat = 20;
            int steps = 3;
            double x = 0.875;
            double y = 1.05;
            double depth = -0.1;
            double depthStep = depth / steps;
            double r = 0.325;
            double millSize = 0.375;
            double xPattern = 0.75;
            using (writer = new StreamWriter("motorPlatePocketsTest.txt"))
            {
                this.StartCode();
                writer.WriteLine("G1 Z0.5");
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + (x - r + millSize / 2).ToString() + "Y" + y.ToString());
                    for (int j = 0; j < steps; j++)
                    {
                        writer.WriteLine("G1 Z" + (0.5 + depthStep + depthStep * j).ToString());
                        writer.WriteLine("G2 X" + (x + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                        writer.WriteLine("G2 X" + (x - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());
                    }
                    writer.WriteLine("G1 Z0.5");
                    if (i < repeat - 1)
                    {
                        writer.WriteLine("G1 X" + ((x + 0.375) - r + millSize / 2).ToString() + "Y" + (y + 0.217).ToString());
                        for (int j = 0; j < steps; j++)
                        {
                            writer.WriteLine("G1 Z" + (0.5 + depthStep + depthStep * j).ToString());
                            writer.WriteLine("G2 X" + ((x + 0.375) + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                            writer.WriteLine("G2 X" + ((x + 0.375) - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());
                        }
                        writer.WriteLine("G1 Z0.5");
                    }
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void PulleyPlateCG()
        {
            double x = 0.75;
            double y = 0.375;
            double xPattern = 0.375;
            int repeat = 28;

            using (writer = new StreamWriter("pulleyPlate.txt"))
            {
                this.StartCode();
                this.FastenerHolesStart(1.25);
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    x += xPattern;
                }
                this.FastenerHolesEnd(1.25);
                this.EndCode();
            }
        }

        public void PulleyPlateSlot()
        {
            double x = 0.6875;
            double y = 0.375;
            double z = 0;
            double depth = 0.25;
            int steps = 10;
            double stepDepth = depth / steps;

            using (writer = new StreamWriter("pulleyPlateSlot.txt"))
            {
                this.StartCode();
                for (int i = 0; i < steps; i+=2)
                {
                    z-=stepDepth;
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z" + z.ToString());
                    z -=stepDepth;
                    writer.WriteLine("G1 X" + (x + 14.625).ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z" + z.ToString());
                }
                writer.WriteLine("G1 Z0.125");
                this.EndCode();
            }
        }

        public void EncoderBase()
        {
            double x = 0.625;
            double y = 0.710;
            double xPattern = 1.375;
            double millSize = 7.0 / 16.0;
            double r = 0.2475;
            double depth = -0.30;
            int repeat = 7;
            int steps = 10;
            double depthStep = depth/steps;

            using (writer = new StreamWriter("encoderBase.txt"))
            {
                this.StartCode();
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + (x - r + millSize / 2).ToString() + "Y" + y.ToString());
                    for (int j = 0; j < steps; j++)
                    {
                        writer.WriteLine("G1 Z" + (depthStep + depthStep * j).ToString());
                        writer.WriteLine("G2 X" + (x + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                        writer.WriteLine("G2 X" + (x - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());
                    }
                    writer.WriteLine("G1 Z0.125");                          
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void AdjustingHoles()
        {
            double x = 0.625;
            double y = 0.710;
            double xPattern = 1.375;
            double millSize = 7.0 / 16.0;
            double r = 0.25;
            int repeat = 7;
           
            using (writer = new StreamWriter("adjustingHoles.txt"))
            {
                this.StartCode();
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z-0.3");
                    writer.WriteLine("G1 X" + (x - r + millSize / 2).ToString() + "Y" + y.ToString());
                    writer.WriteLine("G2 X" + (x + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                    writer.WriteLine("G2 X" + (x - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());                    
                    writer.WriteLine("G1 Z0.125");
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void HexPatternEncoder()
        {
            double x = 0.625;
            double y = 0.710;
            double xPattern = 1.375;
            double r = 0.43307;
            double angle = 0;
            int repeat = 6;

            using (writer = new StreamWriter("hexPattern.txt"))
            {
                this.StartCode();
                for (int i = 0; i < 8; i++)
                {
                    for (int j = 0; j < 6; j++)
                    {
                        writer.WriteLine("G1 X" + (x + r * (Math.Sin(angle))).ToString() + "Y" + (y + r * (Math.Cos(angle))).ToString());
                        writer.WriteLine("G1 Z-0.3");
                        writer.WriteLine("G1 Z0.125");
                        angle += Math.PI / 3.0;
                    }
                    angle = 0;
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void EncoderPlate()
        {
            double x = 0.75;
            double y = 0.25;
            double xPattern = 0.75;
            int repeat = 14;

            using (writer = new StreamWriter("encoderPlate.txt"))
            {
                this.StartCode();
                this.FastenerHolesStart(1.5);
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + (y + 0.5).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + (y + 2).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + (y + 2.5).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 2.5).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 2).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + (y + 0.5).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + 0.375).ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    x += xPattern;
                }
                this.FastenerHolesEnd(1.5);
                this.EndCode();
            }
        }
        
        public void BaseSeparation()
        {
            double x = 1.3125;
            double y = -0.1;
            double depth = -0.27;
            int steps = 16;
            double depthStep = depth / steps;
            double xPattern = 1.375;           
            int repeat = 8;

            using (writer = new StreamWriter("baseSeparation.txt"))
            {
                this.StartCode();
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    for (int j = 0; j < steps; j+=2)
                    { 
                        writer.WriteLine("G1 Z" + (depthStep+depthStep*j).ToString());
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + (y + 2.1).ToString());
                        writer.WriteLine("G1 Z" + (depthStep + depthStep * (j+1)).ToString());
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    }
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void BaseSeparation2()
        {
            double x = 1.3125;
            double y = -0.1;
            double depth = -0.18;
            int steps = 8;
            double depthStep = depth / steps;
            double xPattern = 1.375;
            int repeat = 8;

            using (writer = new StreamWriter("baseSeparation2.txt"))
            {
                this.StartCode();
                for (int i = 0; i < repeat; i++)
                {
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    for (int j = 0; j < steps; j += 2)
                    {
                        writer.WriteLine("G1 Z" + (depthStep + depthStep * j).ToString());
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + (y + 2.1).ToString());
                        writer.WriteLine("G1 Z" + (depthStep + depthStep * (j + 1)).ToString());
                        writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    }
                    x += xPattern;
                }
                this.EndCode();
            }
        }

        public void FastenerHolesStart(double y)
        {
            writer.WriteLine("G1 X0.25Y"+y.ToString());
            writer.WriteLine("G1 Z-0.375");
            writer.WriteLine("G1 Z0.125");
            writer.WriteLine("G1 X1.25");
            writer.WriteLine("G1 Z-0.375");
            writer.WriteLine("G1 Z0.125");
        }

        public void FastenerHolesEnd(double y)
        {
            writer.WriteLine("G1 X14.75Y" + y.ToString());
            writer.WriteLine("G1 Z-0.375");
            writer.WriteLine("G1 Z0.125");
            writer.WriteLine("G1 X15.75");
            writer.WriteLine("G1 Z-0.375");
            writer.WriteLine("G1 Z0.125");
        }

        public void NewMotorPlateHoles(int numPlates)
        {
            double x = 2;
            double y = 1;
            double r = 11.0 / 25.4;
            double xPattern = 4;
            double millDiameter = 0.125;
            int numHoles = 6;
            double angle;
            double angleRad;

            angle = 360.0 / numHoles;

            using (writer = new StreamWriter("newMotorPlateHoles.txt"))
            {
                this.StartCode();
                for (int j = 0; j < numPlates; j++)
                {
                    for (int i = 0; i < numHoles; i++)
                    {
                        angleRad = (i * angle) * Math.PI / 180;
                        writer.WriteLine("G1 X" + (Math.Round(x + r * Math.Cos(angleRad), 4)).ToString() + "Y" + (Math.Round(y + r * Math.Sin(angleRad), 4)).ToString());
                        writer.WriteLine("G1 Z-0.375");

                        writer.WriteLine("G1 Z0.125");
                    }
                    x += xPattern + millDiameter;
                }
                this.EndCode();
            }
        }

        public void NewMotorPlateFastenerHoles(int numPlates)
        {
            double x = 0.5;
            double y = 0.5;
            double xPattern = 3;
            double yPattern = 1;
            double advance = 4;
            double millDiameter = 0.125;

            using (writer = new StreamWriter("newMotorPlateFastenerHoles.txt"))
            {
                this.StartCode();
                for (int j = 0; j < numPlates; j++)
                {
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + x.ToString() + "Y" + (y + yPattern).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + xPattern / 2.0).ToString() + "Y" + (y + yPattern / 2.0).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + xPattern).ToString() + "Y" + (y + yPattern).ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");
                    writer.WriteLine("G1 X" + (x + xPattern).ToString() + "Y" + y.ToString());
                    writer.WriteLine("G1 Z-0.375");
                    writer.WriteLine("G1 Z0.125");

                    x += advance + millDiameter;
               
                }
                
                this.EndCode();
            }
        }

        public void NewMotorPlatePockets(int numPlates)
        {
            int steps = 3;
            double x = 2.0;
            double y = 1.0;
            double depth = -0.1;
            double depthStep = depth / steps;
            double r = 0.325;
            double millSize = 0.375;
            double xPattern = 4;
            double separatingMill = 0.125;
            using (writer = new StreamWriter("newMotorPlatePockets.txt"))
            {
                this.StartCode();
                for (int i = 0; i < numPlates; i++)
                {
                    writer.WriteLine("G1 X" + (x - r + millSize / 2).ToString() + "Y" + y.ToString());
                    for (int j = 0; j < steps; j++)
                    {
                        writer.WriteLine("G1 Z" + (depthStep + depthStep * j).ToString());
                        writer.WriteLine("G2 X" + (x + r - millSize / 2).ToString() + "I" + (r - millSize / 2).ToString());
                        writer.WriteLine("G2 X" + (x - r + millSize / 2).ToString() + "I" + (-(r - millSize / 2)).ToString());
                    }
                    writer.WriteLine("G1 Z0.125");
                    x += xPattern + separatingMill;
                }
                this.EndCode();
            }
        }

        public void NewMotorPlateSeparators(int numPlates)
        {
            double x = 4.0;
            double y = 0;
            double xPattern = 4.0;
            double plateWidth = 2.0;
            double holderThickness = 0.125;
            double millDiameter = 0.125;
            double safe = 0.05;
            int steps = 10;
            double plateThickness = 0.25;
            double stepDepth = plateThickness / (steps + 1);

            using (writer = new StreamWriter("newMotorPlateSeparators.txt"))
            {
                this.StartCode();
                for (int i = 0; i < numPlates; i++)
                {
                    writer.WriteLine("G1 X" + (x + millDiameter / 2.0).ToString());
                    writer.WriteLine("G1 Y" + (y + holderThickness + millDiameter / 2.0 + safe).ToString());
                    for (int j = 0; j < steps; j += 2)
                    {
                        writer.WriteLine("G1 Z" + (- stepDepth - stepDepth * j).ToString());
                        writer.WriteLine("G1 Y" + (y + plateWidth - holderThickness - millDiameter / 2.0 - safe).ToString());
                        writer.WriteLine("G1 Z" + (- stepDepth - stepDepth * (j + 1)).ToString());
                        writer.WriteLine("G1 Y" + (y + holderThickness + millDiameter / 2.0 + safe).ToString());
                    }
                    writer.WriteLine("G1 Z0.125");
                    x += xPattern + millDiameter;
                }
                this.EndCode();
            }
        }

        public void StartCode()
        {
            writer.WriteLine("S600");
            writer.WriteLine("F3");
            writer.WriteLine("M3");
            writer.WriteLine("G1 Z0.125");
        }

        public void EndCode()
        {
            writer.WriteLine("M5");
            writer.WriteLine("M30");
            writer.WriteLine("%");
        }

       
    }
}
